## org.jvnet.maven.plugin.antrun
Class AbstractArtifactsExclusionFilter

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.jvnet.maven.plugin.antrun.GraphFilter
              org.jvnet.maven.plugin.antrun.ListFilter
                  org.jvnet.maven.plugin.antrun.AbstractArtifactsExclusionFilter

All Implemented Interfaces:
  java.lang.Cloneable, GraphVisitor

Direct Known Subclasses:
  ExcludeArtifactsTransitivelyFilter, RemoveSpecificArtifactsFilter

    public abstract class AbstractArtifactsExclusionFilter

extends ListFilter

Base class for `ListFilter`s that takes several nested <artifact> elements as parameters to identify artifacts.

Author:
  Kohsuke Kawaguchi

Field Summary
`protected java.util.Set<java.lang.String>` `ids` IDs of the artifacts to exclude.

Fields inherited from class org.jvnet.maven.plugin.antrun.GraphFilter
`children`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`description, location, project`

Constructor Summary
`protected` `AbstractArtifactsExclusionFilter()`
`protected` `AbstractArtifactsExclusionFilter(java.util.Collection<java.lang.String> artifactIds)`
`protected` `AbstractArtifactsExclusionFilter(java.lang.String... artifactIds)`
`protected` `AbstractArtifactsExclusionFilter(java.lang.String artifactId)`

Method Summary
`protected void` `addArtifact(org.apache.maven.artifact.Artifact a)`
`void` `addConfiguredArtifact(ArtifactElement a)` Nested <artifact> element can be used to specify what artifacts to exclude.
`protected void` `resolve()` Resolves all the artifacts and computes `ids`.

Methods inherited from class org.jvnet.maven.plugin.antrun.ListFilter
`process, visit`

Methods inherited from class org.jvnet.maven.plugin.antrun.GraphFilter
`add, evaluateChild, evaluateChild`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`clone, getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.jvnet.maven.plugin.antrun.GraphVisitor
`visit`

Field Detail

### ids

    protected final java.util.Set<java.lang.String> ids

  IDs of the artifacts to exclude. "groupId:artifactId:classifier". These three are sufficient to identify an artifact uniquely within the context of single project and its dependency.

Constructor Detail

### AbstractArtifactsExclusionFilter

    protected AbstractArtifactsExclusionFilter(java.util.Collection<java.lang.String> artifactIds)
                                        throws java.io.IOException

Throws:
  `java.io.IOException`

### AbstractArtifactsExclusionFilter

    protected AbstractArtifactsExclusionFilter(java.lang.String... artifactIds)
                                        throws java.io.IOException

Throws:
  `java.io.IOException`

### AbstractArtifactsExclusionFilter

    protected AbstractArtifactsExclusionFilter(java.lang.String artifactId)
                                        throws java.io.IOException

Throws:
  `java.io.IOException`

### AbstractArtifactsExclusionFilter

    protected AbstractArtifactsExclusionFilter()

Method Detail

### resolve

    protected final void resolve()

  Resolves all the artifacts and computes `ids`. This normally needs to be done at `GraphVisitor.visit(DependencyGraph.Node)`, because this implementation could be used as a filter. Can be invoked multiple times safely.

### addArtifact

    protected void addArtifact(org.apache.maven.artifact.Artifact a)

### addConfiguredArtifact

    public void addConfiguredArtifact(ArtifactElement a)

  Nested <artifact> element can be used to specify what artifacts to exclude.

Copyright © 2011. All Rights Reserved.